package Friends

import (
	"encoding/json"
	"net/http"

	"git.tovijaeschke.xyz/tovi/Envelope/Backend/Api/Auth"
	"git.tovijaeschke.xyz/tovi/Envelope/Backend/Database"
	"git.tovijaeschke.xyz/tovi/Envelope/Backend/Models"
)

func EncryptedFriendList(w http.ResponseWriter, r *http.Request) {
	var (
		userSession Auth.Session
		friends     []Models.Friend
		returnJson  []byte
		err         error
	)

	userSession, err = Auth.CheckCookie(r)

	if err != nil {
		http.Error(w, "Forbidden", http.StatusUnauthorized)
		return
	}

	friends, err = Database.GetFriendsByUserId(userSession.UserID)
	if err != nil {
		http.Error(w, "Error", http.StatusInternalServerError)
		return
	}

	returnJson, err = json.MarshalIndent(friends, "", "  ")
	if err != nil {
		http.Error(w, "Error", http.StatusInternalServerError)
		return
	}

	w.WriteHeader(http.StatusOK)
	w.Write(returnJson)
}
