package Messages

import (
	"encoding/json"
	"net/http"

	"git.tovijaeschke.xyz/tovi/Envelope/Backend/Database"
	"git.tovijaeschke.xyz/tovi/Envelope/Backend/Models"
	"github.com/gorilla/mux"
)

func MessageThread(w http.ResponseWriter, r *http.Request) {
	var (
		messages   []Models.Message
		urlVars    map[string]string
		threadID   string
		returnJson []byte
		ok         bool
		err        error
	)

	urlVars = mux.Vars(r)
	threadID, ok = urlVars["threadID"]
	if !ok {
		http.Error(w, "Not Found", http.StatusNotFound)
		return
	}

	messages, err = Database.GetMessagesByThreadId(threadID)
	if !ok {
		http.Error(w, "Not Found", http.StatusNotFound)
		return
	}

	returnJson, err = json.MarshalIndent(messages, "", "  ")
	if err != nil {
		http.Error(w, "Error", http.StatusInternalServerError)
		return
	}

	w.WriteHeader(http.StatusOK)
	w.Write(returnJson)
}
